# Pimoroni Pico Explorer Icons
# Tony Goodhew 4th March 2021
# Tested with Pimoroni UF2 Ver: 0.0.8

import picoexplorer as display 
import utime
from machine import Pin
width = display.get_width()
height = display.get_height()
display_buffer = bytearray(width * height * 2)
display.init(display_buffer)

def blk():
    display.set_pen(0,0,0)
    display.clear()
    display.update()

#Defined icons/characters
heart = [0, 108, 254, 254, 124, 56, 16, 0]
b_heart = [0, 108, 222, 238, 116, 56, 16, 0]
duck  = [0, 96, 224,32,127, 254,124,0]
bell = [0, 24,60,126,126,126,255,12]
bits = [128,64,32,16,8,4,2,1]  # Powers of 2

def mychar2(xpos, ypos, pattern):  # Print defined character
    for line in range(8):          # 8x8 characters
        for ii in range(8):
            i = ii
            dot = pattern[line] & bits[i]  # Extract bit
            if dot:  # Only print if a 1
                display.pixel(xpos+i*2, ypos+line*2)
                display.pixel(xpos+i*2, ypos+line*2+1)
                display.pixel(xpos+i*2+1, ypos+line*2)
                display.pixel(xpos+i*2+1, ypos+line*2+1)
                
def mychar3(xpos, ypos, pattern):  # Print defined character
    for line in range(8):          # 8x8 characters
        for ii in range(8):
            i = ii
            dot = pattern[line] & bits[i]  # Extract bit
            if dot:  # Only print if a 1
                display.pixel(xpos+i*3, ypos+line*3)
                display.pixel(xpos+i*3, ypos+line*3+1)
                display.pixel(xpos+i*3, ypos+line*3+2)
                display.pixel(xpos+i*3+1, ypos+line*3)
                display.pixel(xpos+i*3+1, ypos+line*3+1)
                display.pixel(xpos+i*3+1, ypos+line*3+2)
                display.pixel(xpos+i*3+2, ypos+line*3)
                display.pixel(xpos+i*3+2, ypos+line*3+1)
                display.pixel(xpos+i*3+2, ypos+line*3+2)

blk()
display.set_pen(200,200,0)
display.text("Defined characters", 20, 10, 240, 3)
display.set_pen(200,0,0)  
mychar2(20, 60, heart)
mychar3(50, 60, heart)
display.set_pen(0,0,200)
mychar2(20, 85, b_heart)
mychar3(50, 85, b_heart)
display.set_pen(200,200,200)
mychar2(100, 60, duck)
mychar3(130, 60, duck)
display.set_pen(250,180,0)
mychar2(100, 85, bell)
mychar3(130, 85, bell)
display.update()
# Beating heart
for n in range(6):
    display.set_pen(230,0,0)  
    mychar3(50, 60, heart)
    display.update()
    utime.sleep(0.5)
    display.set_pen(90,0,0)  
    mychar3(50, 60, heart)
    display.update()
    utime.sleep(0.5)
display.set_pen(200,0,0)  
mychar3(50, 60, heart)
display.update()
# Swimming Ducks
display.set_pen(100,100,100)
display.text("Press button Y to halt", 5, 180, 230, 2)
display.set_pen(30,40,200) # Water
display.rectangle(0,150,240,18)
y = 130
running = True
while running:
    for xx in range(260, -50, -1):
        display.set_pen(0,0,0) # Wipe old ducks
        display.rectangle(0,y,240,21)
        display.set_pen(200,200,200) # New ducks
        mychar3(xx,y,duck)
        mychar2(xx + 35, y + 7,duck)
        display.update()
        if display.is_pressed(3): # Y button is pressed ?
            running = False  # finish 'while' loop
            break # out of 'for' loop
blk()
display.update()
    